﻿Option Explicit On
Friend Class MaskedTextBoxEnter : Inherits MaskedTextBox
    Private _OldValue As String = Nothing
    Property OldValue As String
        Get
            Return _OldValue
        End Get
        Private Set
            _OldValue = Value
        End Set
    End Property
    Protected Overrides Sub OnKeyPress(e As KeyPressEventArgs)
        If e.KeyChar <> Convert.ToChar(13) Then MyBase.OnKeyPress(e) : Return

        e.Handled = True
        Me.Parent.SelectNextControl(Me, True, True, True, True)
    End Sub
    Protected Overrides Sub OnGotFocus(e As EventArgs)
        OldValue = Me.Text
        MyBase.OnGotFocus(e)
    End Sub
End Class

Friend Class ComboBoxEnter : Inherits ComboBox
    Private _OldValue As String = Nothing
    Property OldValue As String
        Get
            Return _OldValue
        End Get
        Private Set
            _OldValue = Value
        End Set
    End Property
    Protected Overrides Sub OnKeyPress(e As KeyPressEventArgs)
        If e.KeyChar <> Convert.ToChar(13) Then MyBase.OnKeyPress(e) : Return

        e.Handled = True
        Me.Parent.SelectNextControl(Me, True, True, True, True)
    End Sub
    Protected Overrides Sub OnGotFocus(e As EventArgs)
        OldValue = Me.Text
        MyBase.OnGotFocus(e)
    End Sub
End Class
Friend Class TextBoxEnter : Inherits TextBox
    Private _OldValue As String = Nothing
    Property OldValue As String
        Get
            Return _OldValue
        End Get
        Private Set
            _OldValue = Value
        End Set
    End Property
    Protected Overrides Sub OnKeyPress(e As KeyPressEventArgs)
        If e.KeyChar <> Convert.ToChar(13) Then MyBase.OnKeyPress(e) : Return

        e.Handled = True
        Me.Parent.SelectNextControl(Me, True, True, True, True)
    End Sub
    Protected Overrides Sub OnGotFocus(e As EventArgs)
        OldValue = Me.Text
        MyBase.OnGotFocus(e)
    End Sub
End Class